extends Node2D

var start_pos: Vector2
var end_pos: Vector2
var is_drawing: bool = false
	
func _input(event: InputEvent) -> void:
	if event is InputEventMouseButton and event.button_index == MOUSE_BUTTON_LEFT:
		if event.pressed:
			start_pos = event.position
			end_pos = start_pos
			is_drawing = true
		else:
			end_pos = event.position
			is_drawing = false
			slice_floes(start_pos, end_pos)
			queue_redraw()
	elif event is InputEventMouseMotion and is_drawing:
		end_pos = event.position
		queue_redraw()

func _draw() -> void:
	if is_drawing:
		draw_line(start_pos, end_pos, Color.RED, 2)

func slice_floes(splice_start: Vector2, splice_end: Vector2) -> void:
	for child in get_children():
		if child is IceFloe:
			if child.will_line_cut_polygon(splice_start, splice_end):
				var poly_node: Polygon2D = child.get_node("Polygon2D")
				child.splice_with_line(splice_start, splice_end)
