extends Node

signal score_changed
signal highscore_changed
signal game_state_changed

enum GAME_STATE {
	START,
	INGAME,
	GAMEOVER
}

var current_state: GAME_STATE = GAME_STATE.START:
	set(val):
		current_state = val
		emit_signal("game_state_changed", val)

var level_center: Node2D = null

var ice_floes: Array[IceFloe] = []

var camera: Node = null

var score: int = 0:
	set(val):
		score = val
		emit_signal("score_changed", val)

var highscore: int = 0:
	set(val):
		score = val
		emit_signal("highscore_changed", val)

var pengu_group: Node

var _score_timer := Timer.new()

func start_round():
	if not pengu_group:
		printerr("Cant start - No pengu group")
		return
	add_child(_score_timer)
	_score_timer.timeout.connect(func(): score += pengu_group.n_penguins)
	_score_timer.start(1.0)
	current_state = GAME_STATE.INGAME

func reset_round():
	current_state = GAME_STATE.START
	get_tree().reload_current_scene()

@onready
var skull_scene = preload("res://hud/score_popup.tscn")
func create_skull(pos):
	var s = skull_scene.instantiate()
	s.global_position = pos
	get_tree().root.add_child(s)
